/**
 * @file main.c
 * @brief Este projeto demonstra o uso de macros no projeto hello_FRDMKL25Z do led azul piscante (PTE23) 
 * @author Wu Shin Ting
 * @date 6/09/2020
 */

#include "derivative.h" /* include peripheral declarations */

/**
 * @brief atraso em numero de interacoes <i>
 * @param[in] i numero de iteracoes
 */

void delay (unsigned int i)
{
	while (i) i--;
}

/**
 * @brief programa-demo do uso de macros
 */
int main(void)
{
	// Bloco 1: Inicializar
	// Modulo SIM: habilita o clock do modulo PORTE
//	(*(unsigned int volatile *) 0x40048038u) =  (*(unsigned int volatile *) 0x40048038u)| (1<<13); 
	SIM_SCGC5 |= SIM_SCGC5_PORTE_MASK; 
	
	// Modulo PORT: configure o pino PTE23 para GPIO (azul)
//	(*(unsigned int volatile *) 0x4004D05Cu) = (*(unsigned int volatile *) 0x4004D05Cu) & 0xFFFFF8FF;
//	(*(unsigned int volatile *) 0x4004D05Cu) = (*(unsigned int volatile *) 0x4004D05Cu) | 0x00000100;  
	PORTE_PCR23 |= PORT_PCR_MUX (0b001); // mascarar os bits 8, 9 e 10
	
	// Modulo GPIO: configure o sentido do sinal no pino PTE23
	(*(unsigned int volatile *) 0x400FF114u) = (*(unsigned int volatile *) 0x400FF114u)  | (1<<23);   
	GPIOE_PDDR |= (1<<23);    // Seta pino 23 do PORTE como saida 
		
	// Bloco 2: Alternar o estado do led num laco
	for(;;) {
		//Azul
		// Escrever 1 (Set) no pino PTE23 
//		(*(unsigned int volatile *) 0x400FF104u) = (1<<23); 
		GPIOE_PSOR = (1<<23); 
		delay(100000);
	 	// Escrever 0 (Clear) no pino PTE23
//		(*(unsigned int volatile *) 0x400FF108u) = (1<<23);
		GPIOE_PCOR = (1<<23);
		delay(100000);
	}
	
	return 0;
}
